diff --git a/hubs/views/hub.py b/hubs/views/hub.py
index 6641711..3da39d3 100644
--- a/hubs/views/hub.py
+++ b/hubs/views/hub.py
@@ -212,7 +212,7 @@ def hub_add_widget_post(name):
             error = True
             break
         try:
-            param.validator(flask.g.db, val)
+            val = param.validator.from_string(val)
             config[param.name] = val
         except Exception as err:
             flask.flash('Invalid data provided, error: %s' % err, 'error')
@@ -231,6 +231,4 @@ def hub_add_widget_post(name):
                 'Could not save the configuration to the database '
                 'if the error persists, please warn an admin',
                 'error')
-
-    return flask.render_template(
-        'hubs.html', hub=hub, edit=True)
+    return flask.redirect(flask.url_for('hub_edit', name=hub.name))
diff --git a/hubs/views/widget.py b/hubs/views/widget.py
index 192c44d..adc857a 100644
--- a/hubs/views/widget.py
+++ b/hubs/views/widget.py
@@ -48,7 +48,7 @@ def widget_edit_post(hub, idx):
             error = True
             break
         try:
-            val = param.validator(flask.g.db, val)
+            val = param.validator.from_string(val)
             config[param.name] = val
         except Exception as err:
             flask.flash('Invalid data provided, error: %s' % err, 'error')
diff --git a/hubs/widgets/about/__init__.py b/hubs/widgets/about/__init__.py
index bdb7e7b..1de5e0c 100644
--- a/hubs/widgets/about/__init__.py
+++ b/hubs/widgets/about/__init__.py
@@ -1,9 +1,8 @@
 from __future__ import unicode_literals
 
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 
-from hubs import validators
-
 
 class About(Widget):
 
@@ -13,7 +12,7 @@ class About(Widget):
         name="text",
         label="Text",
         default="I am a Fedora user, and this is my about",
-        validator=validators.text,
+        validator=validators.Text,
         help="Text about a user.",
         )]
 
diff --git a/hubs/widgets/badges/__init__.py b/hubs/widgets/badges/__init__.py
index 79315e1..c609776 100644
--- a/hubs/widgets/badges/__init__.py
+++ b/hubs/widgets/badges/__init__.py
@@ -3,7 +3,7 @@ from __future__ import unicode_literals
 import operator
 import requests
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
@@ -16,7 +16,7 @@ class Badges(Widget):
         name="username",
         label="Username",
         default=None,
-        validator=validators.username,
+        validator=validators.Username,
         help="A FAS username.",
         )]
 
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index ac50fd3..38da840 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -23,13 +23,19 @@ class WidgetParameter(object):
     :py:class:`WidgetParameter` objects returned by the widget's
     :py:meth:`~Widget.get_parameters` method.
 
+    The value of the parameter is stored in the database as the value returned
+    by the validator's :py:meth:`from_string` method.  It can thus be a string,
+    an integer, a list, a dict, or any JSON-serializable value.
+
     Attributes:
         name (str): The name of the parameter.
         label (str): A humanized name of the parameter, which will be shown in
             the UI.
         default: The default value if this parameter is not set.
-        validator (function): A validation function that will be called when
-            a user sets the parameter value.
+        validator (hubs.widgets.validators.Validator): A validator subclass
+            that will be used to convert the parameter value to and from
+            string, raising an exception if it is invalid. This attribute
+            points to the validator subclass, not an instance of the class.
         help (str): A help text that will be shown in the UI.
     """
 
diff --git a/hubs/widgets/bugzilla/__init__.py b/hubs/widgets/bugzilla/__init__.py
index c63fa3c..99d02f1 100644
--- a/hubs/widgets/bugzilla/__init__.py
+++ b/hubs/widgets/bugzilla/__init__.py
@@ -3,7 +3,7 @@ from __future__ import unicode_literals
 import requests
 import pkgwat.api
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
@@ -19,7 +19,7 @@ class Bugzilla(Widget):
         name="username",
         label="Username",
         default=None,
-        validator=validators.username,
+        validator=validators.Username,
         help="A FAS username.",
         )]
 
diff --git a/hubs/widgets/dummy/__init__.py b/hubs/widgets/dummy/__init__.py
index ca4bac8..463e359 100644
--- a/hubs/widgets/dummy/__init__.py
+++ b/hubs/widgets/dummy/__init__.py
@@ -1,6 +1,6 @@
 from __future__ import unicode_literals
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 
 
@@ -12,7 +12,7 @@ class Dummy(Widget):
         name="text",
         label="Text",
         default="Lorem ipsum dolor...",
-        validator=validators.text,
+        validator=validators.Text,
         help="Some dummy text to display.",
         )]
 
diff --git a/hubs/widgets/fedmsgstats/__init__.py b/hubs/widgets/fedmsgstats/__init__.py
index 142548f..0b68bcb 100644
--- a/hubs/widgets/fedmsgstats/__init__.py
+++ b/hubs/widgets/fedmsgstats/__init__.py
@@ -5,8 +5,8 @@ import fedmsg.config
 import fedmsg.meta
 import requests
 
-from hubs import validators
 from hubs.utils import commas
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
@@ -21,7 +21,7 @@ class FedmsgStats(Widget):
         name="username",
         label="Username",
         default=None,
-        validator=validators.username,
+        validator=validators.Username,
         help="A FAS username.",
         )]
 
diff --git a/hubs/widgets/feed/__init__.py b/hubs/widgets/feed/__init__.py
index b1f8299..30b39eb 100644
--- a/hubs/widgets/feed/__init__.py
+++ b/hubs/widgets/feed/__init__.py
@@ -1,7 +1,7 @@
 from __future__ import unicode_literals
 
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 
 import logging
@@ -17,13 +17,13 @@ class Feed(Widget):
             "name": "username",
             "label": "Username",
             "default": None,
-            "validator": validators.username,
+            "validator": validators.Username,
             "help": "A FAS username.",
         }, {
             "name": "message_limit",
             "label": "Message limit",
             "default": 20,
-            "validator": validators.integer,
+            "validator": validators.Integer,
             "help": "Max number of feed messages to display.",
         }]
 
diff --git a/hubs/widgets/fhosted/__init__.py b/hubs/widgets/fhosted/__init__.py
index 8f60efa..7b83881 100644
--- a/hubs/widgets/fhosted/__init__.py
+++ b/hubs/widgets/fhosted/__init__.py
@@ -2,7 +2,7 @@ from __future__ import unicode_literals
 
 from six.moves.xmlrpc_client import ServerProxy
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
@@ -16,13 +16,13 @@ class FedoraHosted(Widget):
             name="project",
             label="Project",
             default=None,
-            validator=validators.fedorahosted_project,
+            validator=validators.FedorahostedProject,
             help="Name of the trac instance on fedorahosted.org.",
         ), dict(
             name="n_tickets",
             label="Number of tickets",
             default=4,
-            validator=validators.integer,
+            validator=validators.Integer,
             help="The number of tickets to display.",
         )]
 
@@ -48,7 +48,7 @@ class GetTickets(CachedFunction):
     Queries Fedorahosted via xmlrpc for tickets. '''
 
     def execute(self):
-        n_tickets = int(self.instance.config["n_tickets"])
+        n_tickets = self.instance.config["n_tickets"]
         url = 'https://fedorahosted.org/%s/rpc' \
             % self.instance.config["project"]
         filters = 'status=accepted&status=assigned&status=new&status=reopened'\
diff --git a/hubs/widgets/github_pr/__init__.py b/hubs/widgets/github_pr/__init__.py
index 6961d4a..1d41502 100644
--- a/hubs/widgets/github_pr/__init__.py
+++ b/hubs/widgets/github_pr/__init__.py
@@ -3,7 +3,7 @@ from __future__ import unicode_literals
 import logging
 import hubs.utils
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
@@ -22,13 +22,13 @@ class GitHubPRs(Widget):
             name="organization",
             label="Organization",
             default=None,
-            validator=validators.github_organization,
+            validator=validators.GithubOrganization,
             help="Github Organization or username",
         ), dict(
             name="display_number",
             label="Number of tickets",
             default=6,
-            validator=validators.integer,
+            validator=validators.Integer,
             help="How many pull requests to display at max.",
         )]
 
@@ -42,10 +42,9 @@ class BaseView(WidgetView):
     def get_context(self, instance, *args, **kwargs):
         get_prs = GetPRs(instance)
         org = instance.config["organization"]
-        display_number = int(instance.config["display_number"])
         context = dict(
             organization=org,
-            display_number=display_number,
+            display_number=instance.config["display_number"],
             title="Github: Pull Requests",
         )
         context.update(get_prs())
@@ -56,7 +55,7 @@ class GetPRs(CachedFunction):
 
     def execute(self):
         org = self.instance.config["organization"]
-        display_number = int(self.instance.config["display_number"])
+        display_number = self.instance.config["display_number"]
         log.info("Getting GH prs for %r, (%r)" % (org, display_number))
         token = fedmsg_config.get('github.oauth_token')
         pulls = []
diff --git a/hubs/widgets/githubissues/__init__.py b/hubs/widgets/githubissues/__init__.py
index e29faa7..39d5aa0 100644
--- a/hubs/widgets/githubissues/__init__.py
+++ b/hubs/widgets/githubissues/__init__.py
@@ -2,7 +2,7 @@ from __future__ import unicode_literals
 
 import requests
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
@@ -16,19 +16,19 @@ class GitHubIssues(Widget):
             name="org",
             label="Username",
             default=None,
-            validator=validators.github_organization,
+            validator=validators.GithubOrganization,
             help="Github Organization or username",
         ), dict(
             name="repo",
             label="Repository",
             default=None,
-            validator=validators.github_repo,
+            validator=validators.GithubRepo,
             help="Github repository",
         ), dict(
             name="display_number",
             label="Number of tickets",
             default=10,
-            validator=validators.integer,
+            validator=validators.Integer,
             help="The number of tickets to display.",
         )]
 
@@ -44,7 +44,7 @@ class BaseView(WidgetView):
         return dict(
             org=instance.config["org"],
             repo=instance.config["repo"],
-            display_number=int(instance.config["display_number"]),
+            display_number=instance.config["display_number"],
             title="Github: Newest Open Tickets",
             all_issues=get_issues(),
         )
diff --git a/hubs/widgets/library/__init__.py b/hubs/widgets/library/__init__.py
index 351ec4f..e1d4511 100644
--- a/hubs/widgets/library/__init__.py
+++ b/hubs/widgets/library/__init__.py
@@ -1,7 +1,6 @@
 from __future__ import unicode_literals
 
-from hubs import validators
-from hubs.widgets import clean_input
+from hubs.widgets import clean_input, validators
 from hubs.widgets.base import Widget, WidgetView
 
 
@@ -13,7 +12,7 @@ class Library(Widget):
         name="urls",
         label="URLs",
         default=None,
-        validator=validators.text,
+        validator=validators.Text,
         help="A comma separated list of URLs to add to the library. "
              "External links must include the whole link "
              "(starting with http...)."
diff --git a/hubs/widgets/linechart/__init__.py b/hubs/widgets/linechart/__init__.py
index dfae632..e9765ca 100644
--- a/hubs/widgets/linechart/__init__.py
+++ b/hubs/widgets/linechart/__init__.py
@@ -1,6 +1,6 @@
 from __future__ import unicode_literals
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 
 
@@ -12,7 +12,7 @@ class Linechart(Widget):
         name="username",
         label="Username",
         default=None,
-        validator=validators.username,
+        validator=validators.Username,
         help="A FAS username.",
         )]
 
diff --git a/hubs/widgets/meetings/__init__.py b/hubs/widgets/meetings/__init__.py
index 01908ce..568a04b 100644
--- a/hubs/widgets/meetings/__init__.py
+++ b/hubs/widgets/meetings/__init__.py
@@ -5,8 +5,8 @@ import collections
 import datetime
 import requests
 
-from hubs import validators
 from hubs import utils
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
@@ -20,13 +20,13 @@ class Meetings(Widget):
             name="calendar",
             label="Calendar",
             default=None,
-            validator=validators.required,
+            validator=validators.Required,
             help="A fedocal calendar.",
         ), dict(
             name="n_meetings",
             label="Number of meetings",
             default=4,
-            validator=validators.integer,
+            validator=validators.Integer,
             help="The number of meetings to display.",
         )]
 
@@ -56,7 +56,7 @@ class GetMeetings(CachedFunction):
 
     def execute(self):
         calendar = self.instance.config["calendar"]
-        n_meetings = int(self.instance.config.get("n_meetings", 4))
+        n_meetings = self.instance.config.get("n_meetings", 4)
         base = ('https://apps.fedoraproject.org/calendar/api/meetings/'
                 '?calendar=%s')
         url = base % calendar
diff --git a/hubs/widgets/pagure_pr/__init__.py b/hubs/widgets/pagure_pr/__init__.py
index 518d12d..48c57a0 100644
--- a/hubs/widgets/pagure_pr/__init__.py
+++ b/hubs/widgets/pagure_pr/__init__.py
@@ -1,6 +1,6 @@
 from __future__ import unicode_literals
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
@@ -18,7 +18,7 @@ class PagurePRs(Widget):
             name="repo",
             label="Repository",
             default=None,
-            validator=validators.pagure_repo,
+            validator=validators.PagureRepo,
             help="Pagure repo name.",
         )]
 
diff --git a/hubs/widgets/pagureissues/__init__.py b/hubs/widgets/pagureissues/__init__.py
index 356d59f..7aa36c7 100644
--- a/hubs/widgets/pagureissues/__init__.py
+++ b/hubs/widgets/pagureissues/__init__.py
@@ -2,7 +2,7 @@ from __future__ import unicode_literals
 
 import requests
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
@@ -18,7 +18,7 @@ class PagureIssues(Widget):
             name="repo",
             label="Repository",
             default=None,
-            validator=validators.pagure_repo,
+            validator=validators.PagureRepo,
             help="Pagure repo name",
         )]
 
diff --git a/hubs/widgets/rules/__init__.py b/hubs/widgets/rules/__init__.py
index 498e3a8..1ec9c09 100644
--- a/hubs/widgets/rules/__init__.py
+++ b/hubs/widgets/rules/__init__.py
@@ -2,8 +2,8 @@ from __future__ import unicode_literals
 
 from collections import OrderedDict as ordereddict
 
-from hubs import validators
 from hubs.utils import username2avatar
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 
 
@@ -19,25 +19,25 @@ class Rules(Widget):
             name="link",
             label="Link",
             default=None,
-            validator=validators.link,
+            validator=validators.Link,
             help="Link to the community rules and guidelines.",
         ), dict(
             name="schedule_text",
             label="Schedule text",
             default=None,
-            validator=validators.text,
+            validator=validators.Text,
             help="Some text about when meetings are.",
         ), dict(
             name="schedule_link",
             label="Schedule link",
             default=None,
-            validator=validators.link,
+            validator=validators.Link,
             help="Link to a schedule for IRC meetings, etc.",
         ), dict(
             name="minutes_link",
             label="Minutes link",
             default=None,
-            validator=validators.link,
+            validator=validators.Link,
             help="Link to meeting menutes from past meetings.",
         )]
 
diff --git a/hubs/widgets/sticky/__init__.py b/hubs/widgets/sticky/__init__.py
index 3f038ba..baec759 100644
--- a/hubs/widgets/sticky/__init__.py
+++ b/hubs/widgets/sticky/__init__.py
@@ -1,6 +1,6 @@
 from __future__ import unicode_literals
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 
 
@@ -13,7 +13,7 @@ class Sticky(Widget):
             name="text",
             label="Text",
             default="Lorem ipsum dolor...",
-            validator=validators.text,
+            validator=validators.Text,
             help="Some dummy text to display.",
         )]
 
diff --git a/hubs/widgets/subscriptions/__init__.py b/hubs/widgets/subscriptions/__init__.py
index 1641191..d6dd928 100644
--- a/hubs/widgets/subscriptions/__init__.py
+++ b/hubs/widgets/subscriptions/__init__.py
@@ -3,7 +3,7 @@ from __future__ import unicode_literals
 import flask
 import hubs.models
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
@@ -22,7 +22,7 @@ class Subscriptions(Widget):
             name="username",
             label="Username",
             default=None,
-            validator=validators.username,
+            validator=validators.Username,
             help="A FAS username.",
         )]
 
diff --git a/hubs/widgets/validators.py b/hubs/widgets/validators.py
new file mode 100644
index 0000000..9c96320
--- /dev/null
+++ b/hubs/widgets/validators.py
@@ -0,0 +1,151 @@
+from __future__ import unicode_literals
+
+import flask
+import hubs.models
+import kitchen.text.converters
+import requests
+
+
+class Validator(object):
+    """Convert widget parameters to and from string, and validate their value.
+
+    Validators are used to convert
+    :py:class:`~hubs.widgets.base.WidgetParameter` values to and from string.
+    They will raise an exception if the value is invalid.
+
+    A validator is a subclass of the :py:class:`Validator` class and implements
+    two class methods: :py:meth:`from_string` and :py:meth:`to_string`.
+    """
+
+    @classmethod
+    def from_string(cls, value):
+        """Convert the value from a string to a JSON-serializable value.
+
+        The result of this function will be stored in the database for widget
+        parameters.
+
+        Raises:
+            ValueError: The value is invalid.
+        """
+        if value is None:
+            return ""
+        return value
+
+    @classmethod
+    def to_string(cls, value):
+        """Convert the value to a string.
+
+        The result of this function will be used in the widget configuration
+        form fields.
+        """
+        return value
+
+
+class Required(Validator):
+    """Raises an error if the value is ``False``-like."""
+
+    @classmethod
+    def from_string(cls, value):
+        if not bool(value):
+            raise ValueError("the parameter is required")
+        return value
+
+
+class Text(Validator):
+    """Raises an error if the value can't be converted to unicode."""
+
+    @classmethod
+    def from_string(cls, value):
+        return kitchen.text.converters.to_unicode(value)
+
+
+class Integer(Validator):
+    """Raises an error if the value can't be converted to an integer."""
+
+    @classmethod
+    def from_string(cls, value):
+        return int(value)
+
+
+class Link(Validator):
+    """Raises an error if the value doesn't look like a link."""
+
+    @classmethod
+    def from_string(cls, value):
+        # TODO -- verify that this is actually a link
+        return value
+
+
+class Username(Validator):
+    """Raises an error if the value isn't an existing username.
+
+    There must be a corresponding :py:class:`~hubs.models.User` record.
+
+    This validator does not return the User instance because it is not
+    JSON-serializable, it returns the username unchanged.
+    """
+
+    @classmethod
+    def from_string(cls, value):
+        if hubs.models.User.by_username(value) is not None:
+            return value
+        raise ValueError('Invalid username')
+
+    @classmethod
+    def to_string(cls, value):
+        if value is None and flask.g.auth.logged_in:
+            return flask.g.auth.user.username
+        return value
+
+
+class GithubOrganization(Validator):
+    """Fails if the Github organization name does not exist."""
+
+    @classmethod
+    def from_string(cls, value):
+        # TODO -- implement this.
+        return value
+
+
+class GithubRepo(Validator):
+    """Fails if the Github repository name does not exist."""
+
+    @classmethod
+    def from_string(cls, value):
+        # TODO -- implement this.
+        return value
+
+
+class FMNContext(Validator):
+    """Fails if the value is not a valid FMN context name."""
+
+    @classmethod
+    def from_string(cls, value):
+        # TODO get this from the fedmsg config.
+        if value in [
+            'irc', 'email', 'android', 'desktop', 'hubs',]:
+            return value
+        raise ValueError('Invalid FMN context')
+
+
+class PagureRepo(Validator):
+    """Fails if the Pagure repository name does not exist."""
+
+    @classmethod
+    def from_string(cls, value):
+        response = requests.get("https://pagure.io/%s" % value, timeout=5)
+        if response.status_code == 200:
+            return value
+        raise ValueError('Invalid pagure repo')
+
+
+class FedorahostedProject(Validator):
+    """Fails if the FedoraHosted project name does not exist."""
+
+    @classmethod
+    def from_string(cls, value):
+        response = requests.get("https://fedorahosted.org/%s/" % value,
+                                timeout=5, allow_redirects=False)
+        if response.status_code == 200:
+            return value
+        raise ValueError('Invalid fedorahosted project')
diff --git a/hubs/widgets/workflow/pendingacls.py b/hubs/widgets/workflow/pendingacls.py
index 07fd52b..40c19ec 100644
--- a/hubs/widgets/workflow/pendingacls.py
+++ b/hubs/widgets/workflow/pendingacls.py
@@ -2,8 +2,8 @@ from __future__ import unicode_literals
 
 import requests
 
-from hubs import validators
 from hubs.utils import username2avatar
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
@@ -17,7 +17,7 @@ class PendingACLs(Widget):
             name="username",
             label="Username",
             default=None,
-            validator=validators.username,
+            validator=validators.Username,
             help="A FAS username.",
         )]
 
diff --git a/hubs/widgets/workflow/updates2stable.py b/hubs/widgets/workflow/updates2stable.py
index 79fac1f..4f6f462 100644
--- a/hubs/widgets/workflow/updates2stable.py
+++ b/hubs/widgets/workflow/updates2stable.py
@@ -2,7 +2,7 @@ from __future__ import unicode_literals
 
 import requests
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
@@ -21,7 +21,7 @@ class Updates2Stable(Widget):
             name="username",
             label="Username",
             default=None,
-            validator=validators.username,
+            validator=validators.Username,
             help="A FAS username.",
         )]
 

